use crate::Route;
use yew::prelude::*;
use yew_router::prelude::*;

#[derive(Properties, PartialEq)]
pub struct Props {
    pub children: Children,
    pub to: Route,
}
#[function_component(RouteLink)]
fn route_link(props: &Props) -> Html {
    let route = use_route::<Route>().unwrap();
    let classes = if route == props.to
        || (route.to_path().starts_with(&props.to.to_path()) && props.to.to_path() != "/")
    {
        classes!("route-active")
    } else {
        classes!("")
    };

    html! {
        <Link<Route> classes={classes} to={props.to.clone()}>{for props.children.iter() }</Link<Route>>
    }
}

#[function_component(Navbar)]
pub fn navbar() -> Html {
    html! {
        <div class="navbar">
            <RouteLink to={Route::Home}>{ "Home" }</RouteLink>
            <RouteLink to={Route::Participants}>{ "Deelnemers" }</RouteLink>
            <RouteLink to={Route::Times}>{ "Tijden" }</RouteLink>
        </div>
    }
}
